opal/util/output.h File Reference.TH "opal/util/output.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/util/output.h \- OPAL output stream facility. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include <stdarg.h>\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOPAL_OUTPUT\fP(a)"
.br
.RI "\fIMain macro for use in sending debugging output to output streams; will be 'compiled out' when OPAL is configured without --enable-debug. \fP"
.ti -1c
.RI "#define \fBOPAL_OUTPUT_VERBOSE\fP(a)"
.br
.RI "\fIMacro for use in sending debugging output to the output streams. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBopal_output_stream_t\fP \fBopal_output_stream_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (\fBopal_output_stream_t\fP)"
.br
.RI "\fIDeclare the class of this type. \fP"
.ti -1c
.RI "OMPI_DECLSPEC bool \fBopal_output_init\fP (void)"
.br
.RI "\fIInitializes the output stream system and opens a default 'verbose' stream. \fP"
.ti -1c
.RI "OMPI_DECLSPEC void \fBopal_output_finalize\fP (void)"
.br
.RI "\fIShut down the output stream system. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_output_open\fP (\fBopal_output_stream_t\fP *lds)"
.br
.RI "\fIOpens an output stream. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_output_reopen\fP (int output_id, \fBopal_output_stream_t\fP *lds)"
.br
.RI "\fIRe-opens / redirects an output stream. \fP"
.ti -1c
.RI "OMPI_DECLSPEC bool \fBopal_output_switch\fP (int output_id, bool enable)"
.br
.RI "\fIEnables and disables output streams. \fP"
.ti -1c
.RI "OMPI_DECLSPEC void \fBopal_output_reopen_all\fP (void)"
.br
.ti -1c
.RI "OMPI_DECLSPEC void \fBopal_output_close\fP (int output_id)"
.br
.RI "\fIClose an output stream. \fP"
.ti -1c
.RI "OMPI_DECLSPEC void \fBopal_output\fP (int output_id, const char *format,...)"
.br
.RI "\fIMain function to send output to a stream. \fP"
.ti -1c
.RI "OMPI_DECLSPEC void \fBopal_output_verbose\fP (int verbose_level, int output_id, const char *format,...)"
.br
.RI "\fISend output to a stream only if the passed verbosity level is high enough. \fP"
.ti -1c
.RI "OMPI_DECLSPEC void \fBopal_output_set_verbosity\fP (int output_id, int level)"
.br
.RI "\fISet the verbosity level for a stream. \fP"
.ti -1c
.RI "OMPI_DECLSPEC void \fBopal_output_set_output_file_info\fP (const char *dir, const char *prefix, char **olddir, char **oldprefix)"
.br
.RI "\fISet characteristics for output files. \fP"
.in -1c
.SH "Detailed Description"
.PP 
OPAL output stream facility. 

The OPAL output stream facility is used to send output from the OPAL libraries to output devices. It is meant to fully replace all forms of printf() (and friends). Output streams are opened via the \fBopal_output_open()\fP function call, and then sent output via \fBopal_output_verbose()\fP, \fBOPAL_OUTPUT()\fP, and \fBopal_output()\fP. Streams are closed with \fBopal_output_close()\fP.
.PP
Streams can multiplex output to several kinds of outputs (one of each):
.PP
.IP "\(bu" 2
the syslog
.IP "\(bu" 2
standard output
.IP "\(bu" 2
standard error
.IP "\(bu" 2
file
.PP
.PP
Which outputs to use are specified during \fBopal_output_open()\fP.
.PP
WARNING: When using 'file' as an output destination, be aware that the file may not exist until the session directory for the process exists. This is at least part of the way through MPI_INIT (for example). Most MCA components and internals of Open MPI won't be affected by this, but some RTE / startup aspects of Open MPI will not be able to write to a file for output. See \fBopal_output()\fP for details on what happens in these cases.
.PP
\fBopal_output_open()\fP returns an integer handle that is used in successive calls to \fBOPAL_OUTPUT()\fP and \fBopal_output()\fP to send output to the stream.
.PP
The default 'verbose' stream is opened after invoking \fBopal_output_init()\fP (and closed after invoking \fBopal_output_finalize()\fP). This stream outputs to stderr only, and has a stream handle ID of 0.
.PP
It is erroneous to have one thread close a stream and have another try to write to it. Multiple threads writing to a single stream will be serialized in an unspecified order.
.SH "Define Documentation"
.PP 
.SS "#define OPAL_OUTPUT(a)"
.PP
Main macro for use in sending debugging output to output streams; will be 'compiled out' when OPAL is configured without --enable-debug. 
.PP
\fBSee also:\fP
.RS 4
\fBopal_output()\fP 
.RE
.PP

.SS "#define OPAL_OUTPUT_VERBOSE(a)"
.PP
Macro for use in sending debugging output to the output streams. 
.PP
Will be 'compiled out' when OPAL is configured without --enable-debug.
.PP
\fBSee also:\fP
.RS 4
\fBopal_output_verbose()\fP 
.RE
.PP

.SH "Function Documentation"
.PP 
.SS "OBJ_CLASS_DECLARATION (\fBopal_output_stream_t\fP)"
.PP
Declare the class of this type. 
.PP
Note that the constructor for this class is for convenience only -- it is \fInot\fP necessary to be invoked. If the constructor it used, it sets all values in the struct to be false / 0 (i.e., turning off all output). The intended usage is to invoke the constructor and then enable the output fields that you want. 
.SS "OMPI_DECLSPEC void opal_output (int output_id, const char * format,  ...)"
.PP
Main function to send output to a stream. 
.PP
\fBParameters:\fP
.RS 4
\fIoutput_id\fP Stream id returned from \fBopal_output_open()\fP. 
.br
\fIformat\fP printf-style format string. 
.br
\fIvarargs\fP printf-style varargs list to fill the string specified by the format parameter.
.RE
.PP
This is the main function to send output to custom streams (note that output to the default 'verbose' stream is handled through \fBopal_output_verbose()\fP and opal_output_error()).
.PP
It is never necessary to send a trailing '\\n' in the strings to this function; some streams requires newlines, others do not -- this function will append newlines as necessary.
.PP
Verbosity levels are ignored in this function.
.PP
Note that for output streams that are directed to files, the files are stored under the process' session directory. If the session directory does not exist when \fBopal_output()\fP is invoked, the output will be discarded! Once the session directory is created, \fBopal_output()\fP will automatically create the file and writing to it. 
.SS "OMPI_DECLSPEC void opal_output_close (int output_id)"
.PP
Close an output stream. 
.PP
\fBParameters:\fP
.RS 4
\fIoutput_id\fP Handle of the stream to close.
.RE
.PP
Close an output stream. No output will be sent to the stream after it is closed. Be aware that output handles tend to be re-used; it is possible that after a stream is closed, if another stream is opened, it will get the same handle value. 
.SS "OMPI_DECLSPEC void opal_output_finalize (void)"
.PP
Shut down the output stream system. 
.PP
Shut down the output stream system, including the default verbose stream. 
.SS "OMPI_DECLSPEC bool opal_output_init (void)"
.PP
Initializes the output stream system and opens a default 'verbose' stream. 
.PP
\fBReturn values:\fP
.RS 4
\fItrue\fP Upon success. 
.br
\fIfalse\fP Upon failure.
.RE
.PP
This should be the first function invoked in the output subsystem. After this call, the default 'verbose' stream is open and can be written to via calls to \fBopal_output_verbose()\fP and opal_output_error().
.PP
By definition, the default verbose stream has a handle ID of 0, and has a verbose level of 0. 
.SS "OMPI_DECLSPEC int opal_output_open (\fBopal_output_stream_t\fP * lds)"
.PP
Opens an output stream. 
.PP
\fBParameters:\fP
.RS 4
\fIlds\fP A pointer to \fBopal_output_stream_t\fP describing what the characteristics of the output stream should be.
.RE
.PP
This function opens an output stream and returns an integer handle. The caller is responsible for maintaining the handle and using it in successive calls to \fBOPAL_OUTPUT()\fP, \fBopal_output()\fP, \fBopal_output_switch()\fP, and \fBopal_output_close()\fP.
.PP
If lds is NULL, the default descriptions will be used, meaning that output will only be sent to stderr.
.PP
It is safe to have multiple threads invoke this function simultaneously; their execution will be serialized in an unspecified manner.
.PP
Be sure to see \fBopal_output()\fP for a description of what happens when open_open() / \fBopal_output()\fP is directed to send output to a file but the process session directory does not yet exist. 
.SS "OMPI_DECLSPEC int opal_output_reopen (int output_id, \fBopal_output_stream_t\fP * lds)"
.PP
Re-opens / redirects an output stream. 
.PP
\fBParameters:\fP
.RS 4
\fIoutput_id\fP Stream handle to reopen 
.br
\fIlds\fP A pointer to \fBopal_output_stream_t\fP describing what the characteristics of the reopened output stream should be.
.RE
.PP
This function redirects an existing stream into a new [set of] location[s], as specified by the lds parameter. If the output_is passed is invalid, this call is effectively the same as opening a new stream with a specific stream handle. 
.SS "OMPI_DECLSPEC void opal_output_set_output_file_info (const char * dir, const char * prefix, char ** olddir, char ** oldprefix)"
.PP
Set characteristics for output files. 
.PP
\fBParameters:\fP
.RS 4
\fIdir\fP Directory where output files will go 
.br
\fIolddir\fP If non-NULL, the directory where output files were previously opened 
.br
\fIprefix\fP Prefix of files in the output directory 
.br
\fIoldprefix\fP If non-NULL, the old prefix
.RE
.PP
This function controls the final filename used for all new output streams that request output files. Specifically, when \fBopal_output_stream_t::lds_want_file\fP is true, the output filename will be of the form $dir/$prefix$suffix.
.PP
The default value for the output directory is whatever is specified in the TMPDIR environment variable if it exists, or $HOME if it does not. The default value for the prefix is 'output-pid<pid>-' (where '<pid>' is replaced by the PID of the current process).
.PP
If dir or prefix are NULL, new values are not set. The strings represented by dir and prefix are copied into internal storage; it is safe to pass string constants or free() these values after \fBopal_output_set_output_file_info()\fP returns.
.PP
If olddir or oldprefix are not NULL, copies of the old directory and prefix (respectively) are returned in these parameters. The caller is responsible for calling (free) on these values. This allows one to get the old values, output an output file in a specific directory and/or with a specific prefix, and then restore the old values.
.PP
Note that this function only affects the creation of \fInew\fP streams -- streams that have already started writing to output files are not affected (i.e., their output files are not moved to the new directory). More specifically, the opal_output system only opens/creates output files lazily -- so calling this function affects both new streams \fIand\fP any stream that was previously opened but had not yet output anything. 
.SS "OMPI_DECLSPEC void opal_output_set_verbosity (int output_id, int level)"
.PP
Set the verbosity level for a stream. 
.PP
\fBParameters:\fP
.RS 4
\fIoutput_id\fP Stream id returned from \fBopal_output_open()\fP. 
.br
\fIlevel\fP New verbosity level
.RE
.PP
This function sets the verbosity level on a given stream. It will be used for all future invocations of \fBopal_output_verbose()\fP. 
.SS "OMPI_DECLSPEC bool opal_output_switch (int output_id, bool enable)"
.PP
Enables and disables output streams. 
.PP
\fBParameters:\fP
.RS 4
\fIoutput_id\fP Stream handle to switch 
.br
\fIenable\fP Boolean indicating whether to enable the stream output or not.
.RE
.PP
\fBReturns:\fP
.RS 4
The previous enable state of the stream (true == enabled, false == disabled).
.RE
.PP
The output of a stream can be temporarily disabled by passing an enable value to false, and later resumed by passing an enable value of true. This does not close the stream -- it simply tells the opal_output subsystem to intercept and discard any output sent to the stream via \fBOPAL_OUTPUT()\fP or \fBopal_output()\fP until the output is re-enabled. 
.SS "OMPI_DECLSPEC void opal_output_verbose (int verbose_level, int output_id, const char * format,  ...)"
.PP
Send output to a stream only if the passed verbosity level is high enough. 
.PP
\fBParameters:\fP
.RS 4
\fIoutput_id\fP Stream id returned from \fBopal_output_open()\fP. 
.br
\fIlevel\fP Target verbosity level. 
.br
\fIformat\fP printf-style format string. 
.br
\fIvarargs\fP printf-style varargs list to fill the string specified by the format parameter.
.RE
.PP
Output is only sent to the stream if the current verbosity level is greater than or equal to the level parameter. This mechanism can be used to send 'information' kinds of output to user applications, but only when the user has asked for a high enough verbosity level.
.PP
It is never necessary to send a trailing '\\n' in the strings to this function; some streams requires newlines, others do not -- this function will append newlines as necessary.
.PP
This function is really a convenience wrapper around checking the current verbosity level set on the stream, and if the passed level is less than or equal to the stream's verbosity level, this function will effectively invoke opal_output to send the output to the stream.
.PP
\fBSee also:\fP
.RS 4
\fBopal_output_set_verbosity()\fP 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
